//@ sourceURL=intervenciones.js

jQuery(function($){
	initRupI18nPromise.then(function() {
		prepareData();	
		
		$("#intervenciones_filter_form").rup_validate({
		    liveCheckingErrors: false,
		    showFieldErrorAsDefault: true,
		    showErrorsInFeedback: true,
		    showFieldErrorsInFeedback: true,
		    rules:{
		    	"fIntervencionDesde":{date:true},
		    	"fIntervencionHasta":{date:true},
		    }
		});
		
		$("#intervenciones_filter_form [ruptype='date']").blur(function(elem) { 

			if(!$(elem.target).valid()){
	            $(elem.target).val('')
	        }

		})
	});
	
	function prepareData(){
		
		
		$("#maestroIntervenciones_idTipoIntervencion45_filter_table").rup_combo({
			loadFromSelect:true,
			width: 'auto',
	        ordered: false,
			customClasses: ['select-material'],
			rowStriping: true,
			blank: '',
			selected:''
		});
		
		$.rup_date({
			//yearRange: 'c-100:c+0',
	        from: "fIntervencionDesde_filter_table",
	        to: "fIntervencionHasta_filter_table",
	        mask: 'dd/mm/yyyy',
			showButtonPanel : true,
			showOtherMonths : true,
			noWeekend : true
	     });
		
		/*DOMICILIOS*/
		if($("#idprovincia06_avisos_dialog_table").length == 1){			
			$("#idprovincia06_avisos_dialog_table").rup_combo({
				source:  $.rup.CTX_PATH + 'nora/provincias',
				sourceParam: {label: "descProvincia", value:"codProvincia"},
				rowStriping: true,
				width: 'auto',
				blank: '',
				customClasses: ['select-material'],
				change: function(){
					
				},
				selected: (function(){ try { return solicitantes.direcciones.idProvincia06} catch { return null}})()
			});
			
			
		}
	
	
		if($("#idmunicipio06_avisos_dialog_table").length == 1){
			//MUNICIPIO
			$("#idmunicipio06_avisos_dialog_table").rup_combo({
				parent: ["idprovincia06_avisos_dialog_table"],			
				source: $.rup.CTX_PATH + 'nora/municipioEnlazado',
				sourceParam: {label: "descripcion", value:"codMunicipio"},
				rowStriping: true,
				width: 'auto',
				blank: '',
				customClasses: ['select-material'],
				change: function(){
					
				},
				selected: (function(){ try { return solicitantes.direcciones.idMunicipio06} catch { return null}})()
			});
		}
		const fecha = new Date();
		const anoActual = fecha.getFullYear();
		$("#fIntervencionDesde_filter_table").rup_date("setRupValue", "01/01/"+anoActual);
		
		$("#baja25_filter_table").change(function(){
			if($("#baja25_filter_table").prop("checked")){
				$("#maestroIntervenciones_idTipoIntervencion45_filter_table").rup_combo("setRupValue",9);
			}
		});
		
		$("input[name='_pendiente25']").remove();
		$("input[name='_baja25']").remove();
	
		
		let tableColModels = [			
				
				{ 	name: "solicitantes.identificador01",
					index: "solicitantes.identificador01",
					editable: true, 
					hidden: false
				},			
				{ 	name: "solicitantes.nombre01",
					index: "solicitantes.nombre01",
					editable: true, 
					hidden: false
				},
				{ 	name: "maestroIntervenciones.desc",
					index: "maestroIntervenciones.desc",
					editable: true, 
					hidden: false
				},
				
				{ 	name: "fIntervencion25",
					index: "fIntervencion25",
					editable: true, 
					hidden: false
				},
				{ 	name: "pendiente25",
					index: "pendiente25",
					editable: true, 
					hidden: false
				},
				{ 	name: "baja25",
					index: "baja25",
					editable: true, 
					hidden: false
				},
				{ 	name: 'solicitantes.direcciones.provinciaNORA.descProvincia',
					index: 'solicitantes.direcciones.provinciaNORA.descProvincia',
					editable: true, 
					hidden: false
				},
				{ 	name: 'solicitantes.direcciones.municipioNORA.descripcion',
					index: 'solicitantes.direcciones.municipioNORA.descripcion',
					editable: true, 
					hidden: false
				},
				];
		let columnDefs = [
			{ 
				"targets": 1,
				"render": function(data, type, row, settings){	
					let nombreCompleto="";
					if(row.solicitantes.nombre01!=null){
						nombreCompleto+=row.solicitantes.nombre01;
					}
					if(row.solicitantes.apellido101!=null){
						nombreCompleto+=" "+row.solicitantes.apellido101;
					}
					if(row.solicitantes.apellido201!=null){
						nombreCompleto+=" "+row.solicitantes.apellido201;
					}
					
					return nombreCompleto;
			}
			},
			{ 
				"targets": 4,
				"render": function(data, type, row, settings){	
					
					if( data == 1 ){
						return  `<input type="checkbox" checked="checked" disabled/>`;
					}
					return  `<input type="checkbox" disabled/>`;
				}
			},
			{ 
				"targets": 5,
				"render": function(data, type, row, settings){	
					
					if( data == 1 ){
						return $.rup.i18n.app.comun.si;
					}else{
						return $.rup.i18n.app.comun.no;
					}
				}
			}
			
		];
	
		$("#intervenciones").rup_table({
			colReorder: {
			 fixedColumnsLeft: 1
			}
			,colModel: tableColModels
			,columnDefs : columnDefs
			,primaryKey: "idIntervencion25"
			,filter:{
	  	  		id:"intervenciones_filter_form",
	  	  		filterToolbar:"intervenciones_filter_toolbar",
	  	  		collapsableLayerId:"intervenciones_filter_fieldset",
	  	  		showHidden: true
	     	} 	
			,noEdit : true
	   		,select: {
	       		activate: true
	   		}
			,seeker: {
				activate: true
			}
			,buttons: {
				activate: true,
				contextMenu: false,
				blackListButtons: ['addButton', 'editButton', 'cloneButton', 'copyButton','deleteButton','pdfButton', 'odsButton', 'csvButton'],
			},
			columnOrderArrows: {
			    showOnlyActive: false,
			    display: 'inline'
			}
			,order: [[0, "asc"]]
		});
	}
});